<script>
import { required } from 'vuelidate/lib/validators';
import { error_message, success_message } from "../Helper/helper";
import { settingService } from '../services';


export default {  
  name:'Intergrationmapmodal',
  data() {
    return {
      openModal: false,
      setting: {
        google_map_key: '',
        google_map_api_key: '',
        system_latitude: '',
        system_longitude: '',
        isActiveMapKey:true,
      },
      isLoading:true
    };
  },
  validations: {
    setting: {
      google_map_key: {
        required
      },
      google_map_api_key: {
        required
      },
      system_latitude: {
        required
      },
      system_longitude: {
        required
      },
    },
  },
  mounted() {    
    this.getSetting();
    this.openModal = true
  },

  methods: {
    getSetting() {
      settingService.getSetting().then((response) => {
        if (response.data.code === 200) {
          this.isLoading = false;
          this.setting.google_map_key = response.data.result.google_map_key ?? '',
          this.setting.google_map_api_key = response.data.result.google_map_api_key ?? '',
          this.setting.system_latitude = response.data.result.system_latitude ?? '',
          this.setting.system_longitude = response.data.result.system_longitude ?? ''
        } else {
          this.isLoading = false;
          error_message(response.data.message);
        }
      })
    },

    itemModalClose(e) {
      this.openModal = false;
      this.$emit('modalClose', false)
    },

    fromSubmit() {
      this.$v.setting.$touch();
      if (this.$v.setting.$invalid) {
        return false;
      } else {
        settingService.updateSetting({ data: this.setting }).then((response) => {
          if (response.data.code === 200) {
            success_message(response.data.message);
            this.openModal = false;
            this.$emit('modalClose', false)
          } else {
            error_message(response.data.message);
          }
        })
      }
    },
  },

};
</script>


<template>
  <div>
    <b-modal v-model="openModal" hide-footer scrollable no-close-on-backdrop :title="trans.get('__JSON__.Google Map')" title-class="font-18"
      @hidden="itemModalClose" centered size="lg">
      <template v-if="isLoading">
        <div class="text-center text-danger my-2">
        <b-spinner class="align-middle"></b-spinner>
        <strong>{{trans.get('__JSON__.Loading...')}}</strong>
        </div>
      </template>
      <template v-else>
        <form @submit.prevent="fromSubmit" id="formData">
          <!-- Google Map Key -->
          <div class="row">
            <div class="col-md-12">
              <h6>{{ trans.get('__JSON__.Google Map Key') }}</h6>
            </div>
            <div class="col-md-6">
              <input type="text" class="form-control" v-model="$v.setting.google_map_key.$model"
                :class="{ 'is-invalid': $v.setting.google_map_key.$error }">
              <div v-if="$v.setting.google_map_key.$error" class="invalid-feedback">
                <span v-if="!$v.setting.google_map_key.required">{{ trans.get('__JSON__.This field is required') }}</span>
              </div>
            </div>
          </div>
          <!-- Google Map API Key -->
          <div class="row mt-3">
            <div class="col-md-12">
              <h6>{{ trans.get('__JSON__.Google Map API Key') }}</h6>
            </div>
            <div class="col-md-6">
              <input type="text" class="form-control" v-model="setting.google_map_api_key" :class="{ 'is-invalid': $v.setting.google_map_api_key.$error }">
              <div v-if="$v.setting.google_map_api_key.$error" class="invalid-feedback">
                <span v-if="!$v.setting.google_map_api_key.required">{{ trans.get('__JSON__.This field is required')}}</span>
              </div>
            </div>
          </div>
          <div class="row mt-3">
            <!-- Latitude -->
            <div class="col-md-6">
              <h6>{{ trans.get('__JSON__.Latitude') }}</h6>
              <input type="text" class="form-control" v-model="setting.system_latitude" :class="{ 'is-invalid': $v.setting.system_latitude.$error }">
              <div v-if="$v.setting.system_latitude.$error" class="invalid-feedback">
                <span v-if="!$v.setting.system_latitude.required">{{ trans.get('__JSON__.This field is required') }}</span>
              </div>
            </div>
            <!-- Longitude -->
            <div class="col-md-6">
              <h6>{{ trans.get('__JSON__.Longitude') }}</h6>
              <input type="text" class="form-control" v-model="setting.system_longitude" :class="{ 'is-invalid': $v.setting.system_longitude.$error }">
              <div v-if="$v.setting.system_longitude.$error" class="invalid-feedback">
                <span v-if="!$v.setting.system_longitude.required">{{ trans.get('__JSON__.This field is required')}}</span>
              </div>
            </div>
          </div>
          <hr>
          <div class="row">
            <div class="col-md-12">
              <div class="w-100">
                <b-button variant="primary" @click="fromSubmit" class="float-right add_item_">{{ trans.get("__JSON__.Save") }}</b-button>
                <b-button class="float-left" @click="itemModalClose($event)">{{trans.get("__JSON__.Close")}}</b-button>
              </div>
            </div>
          </div>
        </form>
      </template>      
  </b-modal>
</div>
</template>
<style scoped>
.modal-header .close {
  display:none !important;
}
</style>